<template>
  <div>
    <slot v-if="ready"></slot>
  </div>
</template>

<script>
import { findParentComponentByName } from '@/core/util'

export default {
  name: 'leafletpane',

  props: {
    name: {
      type: String,
      required: true,
    },
    zindex: {
      type: Number,
      required: true,
    },
  },

  // Data for this component only holds information about the ready state
  // of the component
  data() {
    return {
      ready: false,
    }
  },

  methods: {
    // Get reference to the parent LeafletMap component.
    getParentMap() {
      return findParentComponentByName(this.$parent, 'leafletmap')
    },

    // Mark this component as ready to handle leaflet logic
    setReady() {
      this.ready = true
      return this
    },

    // Creates a new pane on the parent map object, with the name and zindex from
    // the props of this component.
    createPane() {
      this.getParentMap().mapObject.createPane(this.name)
      this.getParentMap().mapObject.getPane(this.name).style.zIndex = this.zindex
      return this
    },
  },

  mounted() {
    this.createPane().setReady()
  },
}
</script>
